INTRODUCTION
------------

Current Maintainer: Hussain Abbas <hussainweb@gmail.com>

Taarikh is a field formatter and widget module to display and input hijri
dates using the fields defined by the date module. The formatter can work with
all the fields defined by the date module, i.e., Date, Date (ISO format) and
Date (Unix timestamp). The widget, however, does not work with Date (Unix
timestamp).


REQUIREMENTS
------------

This module requires the following modules:

 * Date 2.x branch (https://drupal.org/project/date)
 * Libraries 2.x branch (https://drupal.org/project/libraries)

In addition, it also needs jquery.calendars library for the hijri calendar
picker. This module is currently tested with version 1.1.4 of the plugin
available here: http://keith-wood.name/zip/jquery.calendars.package-1.1.4.zip

However, it should work with updated versions listed at the plugin download
page at http://keith-wood.name/calendars.html. Please raise an issue if you
face any problems with any other version.


INSTALLATION
------------

 * Install as you would normally install a contributed Drupal module. See
   https://drupal.org/documentation/install/modules-themes/modules-7
   for further information.

 * To use the popup Hijri calendar picker, you will need to install additional
   libraries from the link given in REQUIREMENTS section. Extract the zip file
   in sites/all/libraries such that the following path should exist:
   sites/all/libraries/jquery.calendars/jquery.calendars.js.


CONFIGURATION
-------------

This module provides formatters and widgets for existing date fields.

 * Once the module is installed, visit the Manage Fields page for the content
   type where you want to allow users to input dates using hijri calendar.

 * Create a date field if you do not already have one. 'Date (Unix timestamp)'
   is not supported by widgets right now. Select 'Date' or 'Date (ISO format)'.

 * In widget settings, select 'Select list (Hijri)' or 'Pop-up calendar
   (Hijri)' as per your needs. To use the popup calendar, you should install
   the jquery.calendars library as described in INSTALLATION Section.

 * Go to 'Manage Display' page for the content type and for the date field,
   change the formatter to 'Hijri Date'.

 * To change the format, click on Gear icon on right side of the field to
   choose the date format. Follow the link below the drop down list to add new
   date formats.


DESIGN DECISIONS
----------------

The intention in using date module as against creating a new field type is to
allow maximum portability. Date module is great at storing dates and hijri
calendar is just a different calendar, which can be easily implemented as a
formatter to display dates in hijri and a widget to allow users to input dates
using hijri calendar.

Unfortunately, Date module is very difficult to extend and this has resulted in
a lot of copy/pasted code all over this module. This module has been tested in
production since the release of Date 7.x-2.6 up to the current version, which
is 7.x-2.8.

Date module is due for an overhaul considering it's complexity for handling a
simple use case. It could happen in a 3.x branch at which time, a new branch
will be created for this project as well.

Despite the complexities in using date module, the benefits far outweigh the
drawbacks.

 * This module can be easily enabled or disabled on an existing site without
   worrying about the data.

 * Basic views integration comes for free with date_views module (part of date
   module). Since this is a formatter, it is very simple to change a field in
   a view to use the 'Hijri Date' formatter to show dates in hijri.

 * Filtering by hijri dates is not possible but work is currently in progress
   to implement this as a new submodule.
